//=============================================================================
// SmBase.
//=============================================================================
class SmBase expands spacemarine;

var weapon myWeapon;
var UPakShieldEffect BeamEffect;
var bool bFemale;  
var smbase LastTalker; 
var float LastTalkTime;
var float MessageTime;
var() float  CommandRadius;
var() class<weapon> WeaponType;
var	  Weapon myweap;
var() config float  FriendlyFireScale;
var(Combat) bool	bHasRangedAttack;
var(Combat) bool	bMovingRangedAttack;
var(AI) bool		bTeamLeader;
var 	bool		bCanSpeak;

var int Randsir;

struct MarineSound
{
	var() float Duration;
	var() name UsedInState;
	var() Sound SoundName;
	var byte bPlayed;
	var smbase LastSaidBy;
}; 

var() MarineSound VoiceList[20];

var Pawn SaluteTarget;
var Pawn CommunicateTarget, MsgReceivedFrom;
var int Counting;
var bool bWarnedFriends;
var bool bTransmissionDead;
var bool bCommunicateTargetInRange;
var bool bCommunicating;
var float IncomingMessageLength;

var bool bHuntingTransmitted;
var bool bAcquirePhrase;

var MarineVoiceController PhraseDirector;

var MarineWaveInfo MarineBeamController;
var bool bBeamingIn;
var class< Weapon > StartWeapon;

var() string HumanKillMessage;
		var playerreplicationInfo playerreplication;

event PreBeginPlay()
{
	bIsPlayer = false;
	Super.PreBeginPlay();
	}
	function sethome()
	{
  local NavigationPoint aNode;

		if ( WeaponType != None )
		{
  bIsPlayer = true;
		myweap = Spawn(WeaponType);
		if ( myweap != None )
    {
				myweap.ReSpawnTime = 0.0;
    } 
		}  		
		if ( myWeap != None )
			myWeap.Touch(self);
  else 
  {
  foreach RadiusActors (class'weapon',myweap,collisionradius)
											{
            if (myweap.IsInState('PickUp'))
             {
												  myweap.ReSpawnTime = 0.0;
              myweap.Touch(self);
             }
											}
				} 
  aNode = Level.NavigationPointList;
		while ( aNode != None )
		{
			if ( aNode.IsA('HomeBase') && (aNode.tag == tag) )
			{
				home = HomeBase(aNode);
				return;
			}
			aNode = aNode.nextNavigationPoint;
		}
	}  

function string KillMessage( name damageType, pawn Other )
{
	return(HumanKillMessage);
}
		
function TossWeapon()
{
	if ( Weapon == None )
		return;
	Weapon.FireOffset = Weapon.Default.FireOffset;
	Weapon.PlayerViewOffset = Weapon.Default.PlayerViewOffset;

	Super.TossWeapon();
}
function PostBeginPlay()
{
	local MarineWaveInfo MBC;
	local int LastWave;

 bCanSpeak = true;
	bIsFemale = false;
 LastTalkTime=0;
 MessageTime=0;
 
		if( FRand() < 0.15 )
	{
		bFemale = true;
	}
	
	if( MarineWaveInfo( Owner ) != none )
	{
		MarineBeamController = MarineWaveInfo( Owner );		
		StartWeapon = MarineBeamController.MarineWeapons[ MarineBeamController.CurrentMarine ];
}

else

{

StartWeapon = none;
}
	Super.PostBeginPlay();

if( PlayerReplicationInfo!=None )
{
PlayerReplicationInfo.Destroy();
PlayerReplicationInfo = None;
}
	bIsPlayer = true;
}
function ChangedWeapon()
{
	bIsPlayer = false;
	Super.ChangedWeapon();
		bMovingRangedAttack = true;
	bHasRangedAttack = true;
}
function Touch( Actor Other )
{
Super.Touch(Other);
if( Other.IsA('Inventory') )
{
bIsPlayer = True;
Other.Touch(Self);
bIsPlayer = false;
}
}
simulated function bool AdjustHitLocation(out vector HitLocation, vector TraceDir)
{
Return True;
}
function PlayChallenge() 
{
	local float decision;

	decision = FRand();
	if ( decision < 0.5 )
		TweenToWaiting(0.1);
 else if ( decision < 0.6 )
 PlayAnim('Look1L', 0.8 + 0.6 * FRand(), 0.3);
 else if ( decision < 0.85 )
	    PlayAnim('TalkLg');
	else
					{
					if (Weapon != none)
				 	PlayAnim('TauntL', 1.3);
					else
      TweenToWaiting(0.1);
					}
}
function PlayPatrolStop()
{
 if (Region.Zone.bWaterZone )
 {
  PlaySwimming();
  return; 
 }
 if ( FRand() < 0.1 )
     TweenToWaiting(0.1);  
 else if ( FRand() < 0.3 && weapon !=none)
     PlayAnim('TauntL', 0.5 + 0.5 * FRand(), 0.3);
 else if ( FRand() < 0.35 )
     PlayAnim('Look1L', 0.3 + 0.6 * FRand(), 0.3); 
}
function PlaySwimming()
{
	BaseEyeHeight = 0.7 * Default.BaseEyeHeight;
	if ((Weapon == None) || (Weapon.Mass < 20) )
		LoopAnim('SwimLG');
	else
		LoopAnim('SwimLG');
}
function TweenToWaiting(float tweentime)
{
	if ( Physics == PHYS_Swimming )
	{
		BaseEyeHeight = 0.7 * Default.BaseEyeHeight;
		if ( (Weapon == None) || (Weapon.Mass < 20) )
			TweenAnim('TreadLG', tweentime);
		else
			TweenAnim('TreadLG', tweentime);
	}
	else
	{
		BaseEyeHeight = Default.BaseEyeHeight;
		if ( Enemy != None )
			ViewRotation = Rotator(Enemy.Location - Location);
		else
			ViewRotation.Pitch = 0;
		ViewRotation.Pitch = ViewRotation.Pitch & 65535;
		If ( (ViewRotation.Pitch > RotationRate.Pitch) 
			&& (ViewRotation.Pitch < 65536 - RotationRate.Pitch) )
		{
			If (ViewRotation.Pitch < 32768) 
			{
				if ( (Weapon == None) || (Weapon.Mass < 20) )
					TweenAnim('AimUpL', 0.3);
				else
					TweenAnim('AimUpL', 0.3);
			}
			else
			{
				if ( (Weapon == None) || (Weapon.Mass < 20) )
					TweenAnim('AimDnL', 0.3);
				else
					TweenAnim('AimDnL', 0.3);
			}
		}
		else if ( (Weapon == None) || (Weapon.Mass < 20) )
		{
			TweenAnim('StillFirL', tweentime);
		}
		else
		{
			TweenAnim('StillFirL', tweentime);
		}
	}
}

function TweenToSwimming(float tweentime)
{
	BaseEyeHeight = 0.7 * Default.BaseEyeHeight;
	if ((Weapon == None) || (Weapon.Mass < 20) )
		TweenAnim('SwimLG',tweentime);
	else
		TweenAnim('SwimLG',tweentime);
}
function PlayWaiting()
{
	local name newAnim;
		local float PlayRate;
		if ( Physics == PHYS_Swimming )
	{
		BaseEyeHeight = 0.7 * Default.BaseEyeHeight;
		if ( (Weapon == None) || (Weapon.Mass < 20) )
			LoopAnim('TreadLG');
		else
			LoopAnim('TreadLG');
	}
		else
	{
 	BaseEyeHeight = Default.BaseEyeHeight;
		if ( (Weapon != None) && Weapon.bPointing )
		{
		if ( Weapon.Mass < 20 )
			{
				TweenAnim( 'WalkLgFr', 0.001 );
			}
			else
			{
				TweenAnim( 'WalkLgFr', 0.001 );
			}
		}
		  else
  { 
   if ( FRand() < 0.05 && weapon!=none)
    {
     PlayAnim('TauntL', 0.5 + 0.5 * FRand(), 0.3);
    }
   else if ( FRand() < 0.15 )
    {
     PlayAnim('Look1L', 0.3 + 0.6 * FRand(), 0.3);
    } 
			else
			{
				if ( (Weapon == None) || (Weapon.Mass < 20) )
				{
						newAnim = 'Breath2L';
						newAnim = 'Look1L';
				}
				else
				{
					if ( Health > 50 )
						newAnim = 'Breath1L';
					else
						newAnim = 'Breath2L';
				}
				if ( AnimSequence == newAnim )
				{
					if ( PlayRate != 0 )
					{
						LoopAnim( newAnim, PlayRate );
					}
					else
					{
						LoopAnim(newAnim, 0.3 + 0.7 * FRand());
					}
				}
				else
				{
				
					if ( PlayRate != 0 )
					{
						PlayAnim( newAnim, PlayRate, 0.25 );
					}
					else
					{
						PlayAnim(newAnim, 0.3 + 0.7 * FRand(), 0.25);

					}
				}
				}
				}
				}
				}
function PlayDyingSound()
{
	local float rnd;

	if ( HeadRegion.Zone.bWaterZone )
	{
		if ( FRand() < 0.5 )
			PlaySound(UWHit1, SLOT_Pain,2.0,,,Frand()*0.2+0.9);
		else
			PlaySound(UWHit2, SLOT_Pain,2.0,,,Frand()*0.2+0.9);
			PlaySound(sound'upak.marines.UStatic', SLOT_Talk,2.0);

		return;

	}

	rnd = FRand();
	if (rnd < 0.25)
		PlaySound(Die, SLOT_Talk,2.0);
	else if (rnd < 0.5)
		PlaySound(Die2, SLOT_Talk,2.0);
	else if (rnd < 0.75)
		PlaySound(Die3, SLOT_Talk,2.0);
	else 
		PlaySound(Die4, SLOT_Talk,2.0);
}      
function eAttitude AttitudeTo(Pawn Other)
{
	local byte result;

	 if ( Other.IsA( 'SMbase' ) )
		return ATTITUDE_Friendly;
	return ATTITUDE_Hate;
}
function eAttitude AttitudeWithFear()
{
    return ATTITUDE_Hate;
}

state Acquisition
{ 
 ignores falling, landed; 
 
	function SeePlayer(Actor SeenPlayer)
	{
		if ( SetEnemy(Pawn(SeenPlayer)) )
		{
			MakeNoise(1.0);
			LastSeenPos = Enemy.Location;
		}
	}
Playout:
		//  hurry up
Begin:
 Acceleration = vect(0,0,0);
 SetMovementPhysics();    
 if (Level.TimeSeconds - LastTalkTime > 2.0)
    AcquirePhrase();
	if (Enemy!=none)
 {
 LastSeenPos = Enemy.Location;
 NotifyPeers( 'Attack', Enemy );
	}
 if ( LastTalker==self )
				{
    if (NeedToTurn(LastSeenPos))
	     {	
     		PlayTurning();
	      TurnTo(LastSeenPos);
       FinishAnim();
     	}
     MakeNoise(1.0);
	   	NextAnim = '';
		   gotoState( 'Attacking' );
     }
	if (LastTalker !=none && LastTalker!=self && LastTalker.Health >0)
	{
	//log("state acquisition ....last talker "$LastTalker);
 if ( Enemy == LastTalker.Enemy && LastTalker.Enemy!=none && LastTalker.Enemy.Health >0)
				{
   if (LineOfSightTo(LastTalker) )
			 {   
    if (LastTalker.bTeamLeader )
				 {
      TurnToward( LastTalker ); 
		    PlayAnim( 'SaluteLg', 1.0 );
      if( !bIsFemale )
		    {
			    Randsir = Rand( 2 );
			    if (Randsir==0)
					   PlaySound( sound'Marine.MS208a', SLOT_Talk );  //yes sir
						 else if (Randsir==1)
        PlaySound( sound'Marine.MS208b', SLOT_Talk );  //yes sir
							} 
		  	else
						{
       Randsir = Rand( 2 );
			    if (Randsir==0)
					   PlaySound( sound'Marine.MS308a', SLOT_Talk );  //yes sir
						 else if (Randsir==1) 
        PlaySound( sound'Marine.MS308b', SLOT_Talk );  //yes sir 
						}
     }
    else
     {
						if (FRand()< 0.4)
       {
        TurnToward( LastTalker ); 
		      PlayAnim( 'WaveL', 1.6 );
							}
					}
				}
  else   
   PlayAnim( 'TalkREM', 0.5 );
   FinishAnim();       
   } 
 if (NeedToTurn(LastSeenPos))
	  {	
  	 PlayTurning();
	   TurnTo(LastSeenPos);
    FinishAnim();
   }
 } 
 GotoState( 'Attacking' );
}   

function PlayVictoryDance()
{
 if(HeadRegion.Zone.bWaterZone)
 return; 
	if( FRand() < 0.5 )
	 PlayAnim( 'Victory1L' );
	else
		GotoState( 'KillVictory' );
}

state KillVictory
{

Begin:   
	bFire = 0;
	bAltFire = 0;	
	FinishAnim();
	Acceleration = vect( 0, 0, 0 );
	Velocity = vect( 0, 0, 0 );
	PlayAnim( 'TalkREM', 0.5, 0.1 );
	FinishAnim();
	if( FRand() < 0.5 )
	{
  PlayAnim( 'SaluteLg', 1.0 );
		FinishAnim();
	}
	GotoState( 'Roaming' );
}
function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation,
						Vector momentum, name damageType)
	{     
 if( InstigatedBy!=none )
  {
  if (InstigatedBy.IsA( 'smbase' ) && !Level.Game.bTeamGame )
    Damage=0;  
 	if( InstigatedBy.IsA( 'PlayerPawn' ) && Health <= 230 && Health >= 30 )
 	  {
    if ( Level.TimeSeconds - LastTalkTime > 1.0 && LastTalker!=self )
		      HelpPhrase(); 
   	} 
  }
 	if ( Enemy != None )
		LastSeenPos = Enemy.Location;    
		Super.TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);
}
				
function Talker( smbase Other )
{
 local smbase Friend;

 foreach RadiusActors( class'smbase', Friend, CommandRadius )
	{
		if (Friend != self)
		Friend.Reciever(Other);
	}
}

function Reciever( smbase Other )
{
 local smbase Friend;

		lastTalker=Other;
  LastTalkTime= Level.TimeSeconds;
}

function NotifyPeers( name Message, Pawn Other )
{
	local smbase Friend;  
	
 if ( Level.TimeSeconds - MessageTime < 0.2 )
	return;
 else
	MessageTime = Level.TimeSeconds;
	foreach RadiusActors( class'smbase', Friend, CommandRadius )
	{
		if( Friend != self )
		{
			Friend.PeerNotification( Self, Message, Other );
		}
	}
}

function PeerNotification( Pawn Instigator, name Message, Pawn Other )
	{
  MessageTime = Level.TimeSeconds;    
		if( (message == 'Attack') && (!IsInState('Acquisition') ) && (!IsInState('StartUp')) )
		{
		if( Other != Enemy && SetEnemy( Other ) && Enemy == none )
		 {  
   	LastSeenPos = Enemy.Location;
    GotoState( 'Acquisition' );
		 }  
  }
	}

function Killed( pawn killer, pawn Other, name damageType )
{
	if( Other.IsA( 'SMbase' ) )
	{
		Other.PlaySound( sound'upak.marines.UStatic', SLOT_Talk, 2.0 , true);
	}  	 
	if( Other!=none && Killer == self )
	{
    KillPhrase();
	}   
	Super.Killed( killer, Other, damageType );
}     
			
function KillPhrase()
{
	local int RandNum;
 local float vol;

 LastTalkTime=level.TimeSeconds;
	vol = 10.0;
 LastTalker = self;
 Talker( LastTalker );

		if( !bIsFemale )
		{
			RandNum = Rand( 8 );
			
			if (RandNum==0)
					PlaySound( sound'Marine.MS110', SLOT_Talk,vol );  //target eliminated
			else if (RandNum==1)
					PlaySound( sound'Marine.MS115', SLOT_Talk,vol );  //enemy's dead
			else if (RandNum==2)
					PlaySound( sound'Marine.MS116', SLOT_Talk,vol );  //target eliminated
			else if (RandNum==3)
					PlaySound( sound'Marine.MS210a', SLOT_Talk,vol );  //target eliminated
			else if (RandNum==4)
					PlaySound( sound'Marine.MS210b', SLOT_Talk,vol );  //target eliminated
   else if (RandNum==5)
					PlaySound( sound'Marine.MS216a', SLOT_Talk,vol );  //target eliminated
   else if (RandNum==6)
					PlaySound( sound'Marine.MS215a', SLOT_Talk,vol );  //enemy's dead
   else if (RandNum==7)
					PlaySound( sound'Marine.MS215b', SLOT_Talk,vol );  //enemy's dead
			}
		else
		{
			RandNum = Rand( 5 );
	
	
   if (RandNum==0)
					PlaySound( sound'Marine.MS315a', SLOT_Talk,vol ); //enemies dead
   else if (RandNum==1)
					PlaySound( sound'Marine.MS315b', SLOT_Talk,vol );  //enemies dead
			else if (RandNum==2)
					PlaySound( sound'Marine.MS310b', SLOT_Talk,vol );  //target elim
			else if (RandNum==3)
					PlaySound( sound'Marine.MS316a', SLOT_Talk,vol );  //target elim
			else if (RandNum==4)
					PlaySound( sound'Marine.MS316b', SLOT_Talk,vol );  //target elim
		}
}

function HelpPhrase()
{
	local int RandNum;
 local float vol;

 LastTalkTime=level.TimeSeconds;
	vol = 10.0;
	LastTalker = self;
 Talker( LastTalker );		
		if( !bIsFemale )
		{
   RandNum = Rand( 6 );
   if (RandNum==0)
					PlaySound( sound'Marine.MS214a', SLOT_None,vol );  //I need some help here
			else if (RandNum==1)
					PlaySound( sound'Marine.MS214b', SLOT_None,vol );  //I need some help here
   else if (RandNum==2)
					PlaySound( sound'Marine.MS209a', SLOT_None,vol );  //Im in trouble
   else if (RandNum==3)
					PlaySound( sound'Marine.MS209b', SLOT_None,vol );  //Im in trouble
   else if (RandNum==4)
					PlaySound( sound'Marine.MS204a', SLOT_None,vol );  //Im hit
   else if (RandNum==5)
					PlaySound( sound'Marine.MS204b', SLOT_None,vol );  //Im hit

		}
		else
		{
			RandNum = Rand( 6 );
   if (RandNum==0)
					PlaySound( sound'Marine.MS314a', SLOT_None,vol ); //I need some help here
			else if (RandNum==1)
					PlaySound( sound'Marine.MS314b', SLOT_None,vol ); //I need some help here
   else if (RandNum==2)
					PlaySound( sound'Marine.MS309a', SLOT_None,vol );  //Im in trouble
   else if (RandNum==3)
					PlaySound( sound'Marine.MS309b', SLOT_None,vol );  //Im in trouble
   else if (RandNum==4)
					PlaySound( sound'Marine.MS304a', SLOT_None,vol );  //Im hit
   else if (RandNum==5)
					PlaySound( sound'Marine.MS304b', SLOT_None,vol );  //Im hit

		}
}

function AcquirePhrase()
{
	local int RandNum;
 local float vol;

 LastTalkTime=level.TimeSeconds;
	vol = 10.0;
 LastTalker = self;
 Talker( LastTalker );		

		if( !bIsFemale )
		{
  	RandNum = Rand( 3 );
   
			if (RandNum==0)
					PlaySound( sound'Marine.MS106', SLOT_Talk,vol ); //target acquired
			else if (RandNum==1)
					PlaySound( sound'Marine.MS206a', SLOT_Talk,vol ); //target acquired
			else if (RandNum==2)
					PlaySound( sound'Marine.MS206b', SLOT_Talk,vol ); //target acquired
			}
		else
		{
			RandNum = Rand( 2 );

			if (RandNum==0)
					PlaySound( sound'Marine.MS306a', SLOT_Talk,vol ); //target acquired
			else if (RandNum==1)
					PlaySound( sound'Marine.MS306b', SLOT_Talk,vol );  //target acquired
		}
}

function ChargePhrase()
{
	local int RandNum;
 local float vol;

	vol = 10.0;
	LastTalkTime=level.TimeSeconds;
 LastTalker = self;
 Talker( LastTalker );

		if( !bIsFemale )
		{
  	RandNum = Rand( 13 );
   
			if (RandNum==0)
					PlaySound( sound'Marine.MS111', SLOT_Talk, vol, true );  //fire
			else if (RandNum==1)
					PlaySound( sound'Marine.MS211a', SLOT_Talk, vol, true ); //fire
			else if (RandNum==2)
					PlaySound( sound'Marine.MS211b', SLOT_Talk, vol, true);  //fire
   else if (RandNum==3)
					PlaySound( sound'Marine.MS212a', SLOT_Talk, vol, true ); //open fire
			else if (RandNum==4)
					PlaySound( sound'Marine.MS212b', SLOT_Talk, vol, true ); //open fire
			else if (RandNum==5)
					PlaySound( sound'Marine.MS213a', SLOT_Talk, vol, true ); //attack my target
			else if (RandNum==6)
					PlaySound( sound'Marine.MS213b', SLOT_Talk, vol, true ); //attack my target
			else if (RandNum==7)
					PlaySound( sound'Marine.MS112', SLOT_Talk, vol, true );  //open fire
			else if (RandNum==8)
					PlaySound( sound'Marine.MS113', SLOT_Talk, vol, true );  //attack my target
   else if (RandNum==9)
					PlaySound( sound'Marine.MS205a', SLOT_Talk, vol, true ); //im closing in
			else if (RandNum==10)
					PlaySound( sound'Marine.MS205b', SLOT_Talk, vol, true ); //im closing in
   else if (RandNum==11)
					PlaySound( sound'Marine.MS207a', SLOT_Talk, vol, true ); //go
			else if (RandNum==12)
					PlaySound( sound'Marine.MS207b', SLOT_Talk, vol, true ); //go
		}
		else
		{
			RandNum = Rand( 10 );

			if (RandNum==0)
					PlaySound( sound'Marine.MS305a', SLOT_Talk,vol );  //im closing in
   else if (RandNum==1)
					PlaySound( sound'Marine.MS305b', SLOT_Talk,vol );  //im closing in
			else if (RandNum==2)
					PlaySound( sound'Marine.MS311a', SLOT_Talk,vol );  //fire
			else if (RandNum==3)
					PlaySound( sound'Marine.MS311b', SLOT_Talk,vol );  //fire
			else if (RandNum==4)
					PlaySound( sound'Marine.MS312a', SLOT_Talk,vol );  //open fire
			else if (RandNum==5)
					PlaySound( sound'Marine.MS312b', SLOT_Talk,vol );  //open fire
			else if (RandNum==6)
					PlaySound( sound'Marine.MS313a', SLOT_Talk,vol );  //attack my target
			else if (RandNum==7)
					PlaySound( sound'Marine.MS313b', SLOT_Talk,vol );  //attack my target
   else if (RandNum==8)
					PlaySound( sound'Marine.MS307a', SLOT_Talk,vol );  //go
			else if (RandNum==9)
					PlaySound( sound'Marine.MS307b', SLOT_Talk,vol );  //go
		} 
}
state TacticalMove
{
ignores SeePlayer, HearNoise;

	function SetFall()
	{
		Acceleration = vect(0,0,0);
		Destination = Location;
		NextState = 'Attacking'; 
		NextLabel = 'Begin';
		NextAnim = 'Breath1l';
		GotoState('FallingState');
	}

	function WarnTarget(Pawn shooter, float projSpeed, vector FireDir)
	{	
		if ( bCanFire && (FRand() < 0.4) ) 
			return;

		Super.WarnTarget(shooter, projSpeed, FireDir);
	}

	function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, 
						Vector momentum, name damageType)
	{
		Global.TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);
		if ( health <= 0 )
			return;
		if ( NextState == 'TakeHit' )
		{
			NextState = 'TacticalMove'; 
			NextLabel = 'TakeHit';
			GotoState('TakeHit'); 
		}
	}

	function HitWall(vector HitNormal, actor Wall)
	{
		if (Physics == PHYS_Falling)
			return;
		Focus = Destination;
		//if (PickWallAdjust())
		//	GotoState('TacticalMove', 'AdjustFromWall');
		if ( bChangeDir || (FRand() < 0.5) 
			|| (((Enemy.Location - Location) Dot HitNormal) < 0) )
		{
			DesiredRotation = Rotator(Enemy.Location - location);
			GiveUpTactical(false);
		}
		else
		{
			bChangeDir = true;
			Destination = Location - HitNormal * FRand() * 500;
		}
	}

	function FearThisSpot(Actor aSpot)
	{
		Destination = Location + 120 * Normal(Location - aSpot.Location); 
	}

	function AnimEnd() 
	{
		PlayCombatMove();
	}

	function Timer()
	{
		bReadyToAttack = True;
		Enable('Bump');
		Target = Enemy;	 
 if ( FRand() > 0.5 + 0.17 * skill ) 
			GotoState('RangedAttack');
	}
	 

	function EnemyNotVisible()
	{
		if ( !bGathering && (aggressiveness > relativestrength(enemy)) )
		{
			if (ValidRecovery())
				GotoState('TacticalMove','RecoverEnemy');
			else
				GotoState('Attacking');
		}
		Disable('EnemyNotVisible');
	}

	function bool ValidRecovery()
	{
		local actor HitActor;
		local vector HitLocation, HitNormal;
		
		HitActor = Trace(HitLocation, HitNormal, Enemy.Location, LastSeeingPos, false);
		return (HitActor == None);
	}
		
	function GiveUpTactical(bool bNoCharge)
	{	
		if ( !bNoCharge && (2 * CombatStyle > (3 - Skill) * FRand()) )
			GotoState('Charging');
		else if ( bReadyToAttack && (skill > 3 * FRand() - 1) )
			GotoState('RangedAttack');
		else
			GotoState('RangedAttack', 'Challenge'); 
	}		

	function bool TryToward(inventory Inv, float Weight)
	{
		local bool success; 
		local vector pickdir, collSpec, minDest, HitLocation, HitNormal;
		local Actor HitActor;

		if ( (Weight < 0.0008) && ((Weight < 0.0008 - 0.0002 * skill) 
				|| !Enemy.LineOfSightTo(Inv)) )
			return false;

		pickdir = Inv.Location - Location;
		if ( Physics == PHYS_Walking )
			pickDir.Z = 0;
		pickDir = Normal(PickDir);

		collSpec.X = CollisionRadius;
		collSpec.Y = CollisionRadius;
		collSpec.Z = FMax(6, CollisionHeight - 18);
		
		minDest = Location + FMin(160.0, 3*CollisionRadius) * pickDir;
		HitActor = Trace(HitLocation, HitNormal, minDest, Location, false, collSpec);
		if (HitActor == None)
		{
			success = (Physics != PHYS_Walking);
			if ( !success )
			{
				collSpec.X = FMin(14, 0.5 * CollisionRadius);
				collSpec.Y = collSpec.X;
				HitActor = Trace(HitLocation, HitNormal, minDest - (18 + MaxStepHeight) * vect(0,0,1), minDest, false, collSpec);
				success = (HitActor != None);
			}
			if ( success )
			{
				Destination = Inv.Location;
				bGathering = true;
				if ( 2.7 * FRand() < skill )
					GotoState('TacticalMove','DoStrafeMove');
				else
					GotoState('TacticalMove','DoDirectMove');
				return true;
			}
		}

		return false;
	}

	function PainTimer()
	{
		if ( (FootRegion.Zone.bPainZone) && (FootRegion.Zone.DamagePerSec > 0)
			&& (FootRegion.Zone.DamageType != ReducedDamageType) )
			GotoState('Retreating');
		Super.PainTimer();
	}


/* PickDestination()
Choose a destination for the tactical move, based on aggressiveness and the tactical
situation. Make sure destination is reachable
*/
	function PickDestination(bool bNoCharge)
	{
		local inventory Inv, BestInv, SecondInv;
		local float Bestweight, NewWeight, MaxDist, SecondWeight;

		// possibly pick nearby inventory
		// higher skill bots will always strafe, lower skill
		// both do this less, and strafe less

		if ( !bReadyToAttack && (TimerRate == 0.0) )
			SetTimer(0.7, false);
		if ( Level.TimeSeconds - LastInvFind < 2.5 - 0.5 * skill )
		{
			PickRegDestination(bNoCharge);
			return;
		}

		LastInvFind = Level.TimeSeconds;
		bGathering = false;
		BestWeight = 0;
		MaxDist = 600 + 70 * skill;
		foreach visiblecollidingactors(class'Inventory', Inv, MaxDist)
			if ( (Inv.IsInState('PickUp')) && (Inv.MaxDesireability/200 > BestWeight)
				&& (Inv.Location.Z < Location.Z + MaxStepHeight + CollisionHeight)
				&& (Inv.Location.Z > FMin(Location.Z, Enemy.Location.Z) - CollisionHeight) )
			{
				NewWeight = inv.BotDesireability(self)/VSize(Inv.Location - Location);
				if ( NewWeight > BestWeight )
				{
					SecondWeight = BestWeight;
					BestWeight = NewWeight;
					SecondInv = BestInv;
					BestInv = Inv;
				}
			}

		if ( BestInv == None )
		{
			PickRegDestination(bNoCharge);
			return;
		}

		if ( TryToward(BestInv, BestWeight) )
			return;

		if ( SecondInv == None )
		{
			PickRegDestination(bNoCharge);
			return;
		}

		if ( TryToward(SecondInv, SecondWeight) )
			return;

		PickRegDestination(bNoCharge);
	}

	function PickRegDestination(bool bNoCharge)
	{
		local vector pickdir, enemydir, enemyPart, Y, minDest;
		local actor HitActor;
		local vector HitLocation, HitNormal, collSpec;
		local float Aggression, enemydist, minDist, strafeSize, optDist;
		local bool success, bNoReach;
	
		bChangeDir = false;
		if (Region.Zone.bWaterZone && !bCanSwim && bCanFly)
		{
			Destination = Location + 75 * (VRand() + vect(0,0,1));
			Destination.Z += 100;
			return;
		}
		if ( Enemy.Region.Zone.bWaterZone )
			bNoCharge = bNoCharge || !bCanSwim;
		else 
			bNoCharge = bNoCharge || (!bCanFly && !bCanWalk);
		
		success = false;
		enemyDist = VSize(Location - Enemy.Location);
		Aggression = 2 * (CombatStyle + FRand()) - 1.1;
		if ( Enemy.bIsPlayer && (AttitudeTo(Enemy) == ATTITUDE_Fear) && (CombatStyle > 0) )
			Aggression = Aggression - 2 - 2 * CombatStyle;
		if ( Weapon != None )
			Aggression += 2 * Weapon.SuggestAttackStyle();
		if ( Enemy.Weapon != None )
			Aggression += 2 * Enemy.Weapon.SuggestDefenseStyle();

		if ( enemyDist > 1000 )
			Aggression += 1;
		if ( !bNoCharge )
			bNoCharge = ( Aggression < FRand() );

		if ( (Physics == PHYS_Walking) || (Physics == PHYS_Falling) )
		{
			if (Location.Z > Enemy.Location.Z + 140) //tactical height advantage
				Aggression = FMax(0.0, Aggression - 1.0 + CombatStyle);
			else if (Location.Z < Enemy.Location.Z - CollisionHeight) // below enemy
			{
				if ( !bNoCharge && (Aggression > 0) && (FRand() < 0.6) )
				{
					GotoState('Charging');
					return;
				}
				else if ( (enemyDist < 1.1 * (Enemy.Location.Z - Location.Z)) 
						&& !actorReachable(Enemy) ) 
				{
					bNoReach = true;
					aggression = -1.5 * FRand();
				}
			}
		}
	
		if (!bNoCharge && (Aggression > 2 * FRand()))
		{
			if ( bNoReach && (Physics != PHYS_Falling) )
			{
				TweenToRunning(0.15);
				GotoState('Charging', 'NoReach');
			}
			else
				GotoState('Charging');
			return;
		}

		if (enemyDist > FMax(VSize(OldLocation - Enemy.OldLocation), 240))
			Aggression += 0.4 * FRand();
			 
		enemydir = (Enemy.Location - Location)/enemyDist;
		minDist = FMin(160.0, 3*CollisionRadius);
		optDist = 80 + FMin(EnemyDist, 250 * (FRand() + FRand()));  
		Y = (enemydir Cross vect(0,0,1));
		if ( Physics == PHYS_Walking )
		{
			Y.Z = 0;
			enemydir.Z = 0;
		}
		else 
			enemydir.Z = FMax(0,enemydir.Z);
			
		strafeSize = FMax(-0.7, FMin(0.85, (2 * Aggression * FRand() - 0.3)));
		enemyPart = enemydir * strafeSize;
		strafeSize = FMax(0.0, 1 - Abs(strafeSize));
		pickdir = strafeSize * Y;
		if ( bStrafeDir )
			pickdir *= -1;
		bStrafeDir = !bStrafeDir;
		collSpec.X = CollisionRadius;
		collSpec.Y = CollisionRadius;
		collSpec.Z = FMax(6, CollisionHeight - 18);
		
		minDest = Location + minDist * (pickdir + enemyPart);
		HitActor = Trace(HitLocation, HitNormal, minDest, Location, false, collSpec);
		if (HitActor == None)
		{
			success = (Physics != PHYS_Walking);
			if ( !success )
			{
				collSpec.X = FMin(14, 0.5 * CollisionRadius);
				collSpec.Y = collSpec.X;
				HitActor = Trace(HitLocation, HitNormal, minDest - (18 + MaxStepHeight) * vect(0,0,1), minDest, false, collSpec);
				success = (HitActor != None);
			}
			if (success)
				Destination = minDest + (pickdir + enemyPart) * optDist;
		}
	
		if ( !success )
		{					
			collSpec.X = CollisionRadius;
			collSpec.Y = CollisionRadius;
			minDest = Location + minDist * (enemyPart - pickdir); 
			HitActor = Trace(HitLocation, HitNormal, minDest, Location, false, collSpec);
			if (HitActor == None)
			{
				success = (Physics != PHYS_Walking);
				if ( !success )
				{
					collSpec.X = FMin(14, 0.5 * CollisionRadius);
					collSpec.Y = collSpec.X;
					HitActor = Trace(HitLocation, HitNormal, minDest - (18 + MaxStepHeight) * vect(0,0,1), minDest, false, collSpec);
					success = (HitActor != None);
				}
				if (success)
					Destination = minDest + (enemyPart - pickdir) * optDist;
			}
			else 
			{
				if ( (CombatStyle <= 0) || (Enemy.bIsPlayer && (AttitudeTo(Enemy) == ATTITUDE_Fear)) )
					enemypart = vect(0,0,0);
				else if ( (enemydir Dot enemyPart) < 0 )
					enemyPart = -1 * enemyPart;
				pickDir = Normal(enemyPart - pickdir + HitNormal);
				minDest = Location + minDist * pickDir;
				collSpec.X = CollisionRadius;
				collSpec.Y = CollisionRadius;
				HitActor = Trace(HitLocation, HitNormal, minDest, Location, false, collSpec);
				if (HitActor == None)
				{
					success = (Physics != PHYS_Walking);
					if ( !success )
					{
						collSpec.X = FMin(14, 0.5 * CollisionRadius);
						collSpec.Y = collSpec.X;
						HitActor = Trace(HitLocation, HitNormal, minDest - (18 + MaxStepHeight) * vect(0,0,1), minDest, false, collSpec);
						success = (HitActor != None);
					}
					if (success)
						Destination = minDest + pickDir * optDist;
				}
			}	
		}
					
		if ( !success )
			GiveUpTactical(bNoCharge);
		else 
		{
			pickDir = (Destination - Location);
			enemyDist = VSize(pickDir);
			if ( enemyDist > minDist + 2 * CollisionRadius )
			{
				pickDir = pickDir/enemyDist;
				HitActor = Trace(HitLocation, HitNormal, Destination + 2 * CollisionRadius * pickdir, Location, false);
				if ( (HitActor != None) && ((HitNormal Dot pickDir) < -0.6) )
					Destination = HitLocation - 2 * CollisionRadius * pickdir;
			}
		}
	}

	function BeginState()
	{
		
		MinHitWall += 0.15;
		bAvoidLedges = ( !bCanJump && (CollisionRadius > 40) );
		bCanJump = false;
		bCanFire = false;
	}
	
	function EndState()
	{
		bAvoidLedges = false;
		MinHitWall -= 0.15;
		if (JumpZ > 0)
			bCanJump = true;
	}

//FIXME - what if bReadyToAttack at start
TacticalTick:
	Sleep(0.02);	
Begin:
	TweenToRunning(0.15);
	Enable('AnimEnd');
	if (Physics == PHYS_Falling)
	{
		DesiredRotation = Rotator(Enemy.Location - Location);
		Focus = Enemy.Location;
		Destination = Enemy.Location;
		WaitForLanding();
	}
	PickDestination(false);

DoMove:
	if ( !bCanStrafe )
	{ 
DoDirectMove:
		Enable('AnimEnd');
		if ( GetAnimGroup(AnimSequence) == 'MovingAttack' )
		{
			AnimSequence = '';
			TweenToRunning(0.12);
		}
		HaltFiring();
		MoveTo(Destination);
	}
	else
	{
DoStrafeMove:
		Enable('AnimEnd');
		bCanFire = true;
		StrafeFacing(Destination, Enemy);	
	}

	if ( (Enemy != None) && !LineOfSightTo(Enemy) && ValidRecovery() )
		Goto('RecoverEnemy');
	else
	{
		bReadyToAttack = true;
		GotoState('Attacking');
	}
	
NoCharge:
	TweenToRunning(0.15);
	Enable('AnimEnd');
	if (Physics == PHYS_Falling)
	{
		DesiredRotation = Rotator(Enemy.Location - Location);
		Focus = Enemy.Location;
		Destination = Enemy.Location;
		WaitForLanding();
	}
	PickDestination(true);
	Goto('DoMove');
	
AdjustFromWall:
	Enable('AnimEnd');
	StrafeTo(Destination, Focus); 
	Destination = Focus; 
	Goto('DoMove');

TakeHit:
	TweenToRunning(0.12);
	Goto('DoMove');

RecoverEnemy:
	Enable('AnimEnd');
	bReadyToAttack = true;
	HidingSpot = Location;
	bCanFire = false;
	Destination = LastSeeingPos + 3 * CollisionRadius * Normal(LastSeeingPos - Location);
	if ( bCanStrafe || (VSize(LastSeeingPos - Location) < 3 * CollisionRadius) )
		StrafeFacing(Destination, Enemy);
	else
		MoveTo(Destination);
	if ( Weapon == None ) 
		Acceleration = vect(0,0,0);
	if ( NeedToTurn(Enemy.Location) )
	{
		PlayTurning();
		TurnToward(Enemy);
	}
	if ( CanFireAtEnemy() )
	{
		Disable('AnimEnd');
		DesiredRotation = Rotator(Enemy.Location - Location);
		if ( Weapon == None ) 
		{
			PlayRangedAttack();
			FinishAnim();
			TweenToRunning(0.1);
			bReadyToAttack = false;
			SetTimer(TimeBetweenAttacks, false);
		}
		else
		{
			FireWeapon();
			if ( Weapon.bSplashDamage )
			{
				bFire = 0;
				bAltFire = 0;
				Acceleration = vect(0,0,0);
				Sleep(0.1);
			}
		}

		if ( (FRand() + 0.1 > CombatStyle) )
		{
			Enable('EnemyNotVisible');
			Enable('AnimEnd');
			Destination = HidingSpot + 4 * CollisionRadius * Normal(HidingSpot - Location);
			Goto('DoMove');
		}
	}

	GotoState('Attacking');
}	
auto state StartUp
{
	ignores bump, takedamage;

	function BeginState()
	{
		bIsPlayer = true; 
		if( bBeamingIn )
		{
			Style = STY_Translucent;
			bMeshEnviroMap = True;
			Texture = Texture'CloakTexture';
			ScaleGlow = 0.01;
			Fatness = 250;
		}	
		SetMovementPhysics(); 
		if ( Physics == PHYS_Walking )
		{
			SetPhysics( PHYS_Falling );
		}
		if( StartWeapon == none )
		{
			startWeapon = Weapontype;
			myweapon.PickupSound = none;

myWeapon.SelectSound = none;

myWeapon.CockingSound = none;

		myWeapon.ReSpawnTime = 0.0;
		}
		if ( StartWeapon != None )

{
			bIsPlayer = true;
myWeapon = Spawn( StartWeapon );

myWeapon.PickupSound = none;

myWeapon.SelectSound = none;

myWeapon.CockingSound = none;

		myWeapon.ReSpawnTime = 0.0;
	}

			}


Begin:
	myWeapon.Touch( self );
	if( MarineBeamController != none )
	{
		bHidden = true;
		Land = none;
		LandGrunt = none;
		Spawn( class'Octagon',,, Location );
		Sleep( 2.0 );
		GotoState( 'BeamingIn' );
	}
	else
	{
		Mesh = default.Mesh;
		Style = STY_Normal;
		bMeshEnviroMap = False;
		Texture = Default.Texture;
		Skin = Default.Skin;
		ScaleGlow = Default.ScaleGlow;
		Fatness = Default.Fatness;
		if( Weapon != none )
		{
			Weapon.Style = STY_Normal;
			Weapon.bMeshEnviroMap = false;
			Weapon.Texture = Weapon.Default.Texture;
			Weapon.Scaleglow = Weapon.Default.ScaleGlow;
			Weapon.Fatness = Weapon.Default.Fatness;
		}

		WhatToDoNext('','');
	}
	
}

		
state RangedAttack
{ 
ignores SeePlayer, HearNoise, Bump;

Challenge:
	Disable('AnimEnd');
	Acceleration = vect(0,0,0); //stop
	DesiredRotation = Rotator(Enemy.Location - Location);
	PlayChallenge();
	FinishAnim();
	TweenToFighter(0.1);
	Goto('FaceTarget');

Begin:
	if ( Target == None )
	{
  if ( Enemy != None )
		Target = Enemy;
		if ( Target == None )
			GotoState('Attacking');
	}
	Acceleration = vect(0,0,0); //stop
	DesiredRotation = Rotator(Target.Location - Location);
	TweenToFighter(0.15);

FaceTarget:
	Disable('AnimEnd');
	if (NeedToTurn(Target.Location))
	{
		PlayTurning();
		TurnToward(Target);
		TweenToFighter(0.1);
	}
	FinishAnim();


ReadyToAttack:
	if (!bHasRangedAttack)
		GotoState('Attacking');
	DesiredRotation = Rotator(Target.Location - Location);
	PlayRangedAttack();
	Enable('AnimEnd');

Firing:
	if ( Target == None )
		GotoState('Attacking');
	TurnToward(Target);
	Goto('Firing');

DoneFiring:
	Disable('AnimEnd');
	KeepAttacking();
	Goto('FaceTarget');
}      


state Dying
{
ignores SeePlayer, EnemyNotVisible, HearNoise, KilledBy, Trigger, Bump, HitWall, HeadZoneChange, FootZoneChange, ZoneChange, Falling, WarnTarget, Died, LongFall, PainTimer;

	function ReStartPlayer()
	{
		if( bHidden && Level.Game.RestartPlayer(self) )
		{
			Velocity = vect(0,0,0);
			Acceleration = vect(0,0,0);
			ViewRotation = Rotation;
			ReSetSkill();
			SetPhysics(PHYS_Falling);
			GotoState('Roaming');
		}
		else
			GotoState('Dying', 'TryAgain');
	}
	
	function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, 
							Vector momentum, name damageType)
	{
		if ( !bHidden )
			Super.TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);
	}
	
	function BeginState()
	{
		if( Weapon != none )
		{
			Weapon.Destroy();
		}
		
        SetTimer(0.3, false);
		Enemy = None;
		AmbushSpot = None;
		bFire = 0;
		bAltFire = 0;
		if( Weapon != none )
		{
			Weapon.AmmoType.AmmoAmount = Weapon.Default.AmmoType.AmmoAmount - Rand( 4 );
		}
		if( MarineBeamController != none )
		{
			MarineBeamController.SubtractMarine( Self );
		}
		bHidden = true;
		SpawnCarcass();
		if( !Level.Game.IsA( 'MarineMatch' ) )
		{
			Destroy();
		}
	}

	function EndState()
	{
		if ( Health <= 0 )
			log(self$" health still <0");
}
Begin:
Stop;

/*Begin:
	Sleep(0.2);
	if ( !bHidden )
	{
		SpawnCarcass();
		HidePlayer();
	}
TryAgain:
	Sleep(0.25 + DeathMatchGame(Level.Game).NumBots * FRand());
	ReStartPlayer();
	Goto('TryAgain');
WaitingForStart:
	bHidden = true;*/
}


// Beaming in effect is a placeholder

state BeamingIn
{
	ignores TakeDamage, Bump, SeePlayer;
	
	function BeginState()
	{
		local UPakShieldEffect UPSE;
		Mass = 20000;
		Fatness = 5;
		Land = default.Land;
		LandGrunt = default.LandGrunt;
		bHidden = false;		
		LoopAnim( 'Breath2l', 0.3 );
//		Style = STY_Translucent;
//		bMeshEnviroMap = True;
//		Texture = Texture'CloakTexture';
//		Skin = Texture'CloakTexture';
//		ScaleGlow = 0.01;
//		Fatness = 250;
		Style = STY_Translucent;
		ScaleGlow = 0.0;
		PlaySound( sound'CloakOff' );	
		BeamEffect = Spawn( class'UPakShieldEffect', Self,, Location, Rotation );
		BeamEffect.Mesh = Mesh;	
		BeamEffect.DrawScale = DrawScale;	
//		if( Weapon != none )
//		{
//			UPSE = Spawn( class'UPakShieldEffect', Weapon,, Weapon.Location, Weapon.Rotation );
//		}
		if( Weapon != none )
		{
			Weapon.Style = STY_Translucent;
			Weapon.bMeshEnviroMap = true;
            Weapon.Texture = Texture'upak.beamtexture';
			Weapon.ScaleGlow = 0.01;
			Weapon.Fatness = 250;
		}
		
		SetTimer( 3.5, False );
	}
	
	function Tick( float DeltaTime )
	{
//		if( ScaleGlow < 1.5 )
//		{
//			ScaleGlow += 0.01;
			if( Weapon != none && Weapon.ScaleGlow < 1.5 )
			{
				Weapon.ScaleGlow += 0.001;
			}
			else
			{
				Weapon.Style = STY_Normal;
				Weapon.bMeshEnviroMap = false;
				Weapon.ScaleGlow = Weapon.Default.ScaleGlow;
				Weapon.Texture = Weapon.Default.Texture;
				Weapon.Fatness = Weapon.Default.Fatness;
			}
			
	if( bHidden )
		{
			bHidden = false;
			Weapon.bHidden = false;
		}
		
		else
		
		if( FRand() < 0.2 && !bHidden )
		{
			bHidden = true;
			Weapon.bHidden = true;
		}
		

//			if( Fatness > Default.Fatness )
//	{
//		Fatness -= 10;
				if( Weapon != none && Weapon.Fatness > Weapon.Default.Fatness )
				{
					Weapon.Fatness -= 10;
				}
//	}
//}
		if( Fatness < 128 )
		{
			Fatness++;
		}
		
	}
	
	function Timer()
	{
		BeamEffect.GotoState( 'OwnerFadeIn' );
//		bHidden = false;
//		Disable( 'Tick' );
//		Style = STY_Normal;
		bHidden = false;
		bMeshEnviroMap = False;
//		Texture = Default.Texture;
//		Skin = Default.Skin;
//		ScaleGlow = Default.ScaleGlow;
//		Fatness = Default.Fatness;
//		if( Weapon != none )
//		{
//			Weapon.Style = STY_Normal;
//			Weapon.bMeshEnviroMap = false;
//			Weapon.Texture = Weapon.Default.Texture;
//			Weapon.Scaleglow = Weapon.Default.ScaleGlow;
//			Weapon.Fatness = Weapon.Default.Fatness;
//		}
	}

Begin:
	if( Enemy != none )
	{
		TurnToward( Enemy );
	}
	
	else
	{
		TurnToward( MarineBeamController.GetPlayerPawn() );
//		Enemy = MarineBeamController.GetPlayerPawn();
	}
	
	sleep( 5.5 );
	bHidden = false;
	Style=STY_Normal;
	Weapon.Texture = Weapon.Default.Texture;
	Weapon.ScaleGlow = Weapon.Default.ScaleGlow;
	Mass = Default.Mass;
	Weapon.Fatness = Weapon.Default.Fatness;
	Weapon.bMeshEnviroMap = false;
	Weapon.Style=STY_Normal;
//	BeamEffect.Fatness = 129;
	BeamEffect.LifeSpan = 1;
	BeamEffect.Texture = texture'upak.Beam2';
	Enemy = MarineBeamController.GetPlayerPawn();
	Target = MarineBeamController.GetPlayerPawn();
	Fatness = Default.Fatness;
	GotoState( 'Hunting' );
//	WhatToDoNext( '', '' );
}

		
function FireWeapon()
{
	local bool bUseAltMode;

	if( Weapon != none )
	{
		Weapon.AmmoType.AmmoAmount = 999;
	}
	
	if ( (Enemy == None) && bShootSpecial )
	{
		//fake use dispersion pistol
		Spawn(class'DispersionAmmo',,, Location,Rotator(Target.Location - Location));
		return;
	}

	bUseAltMode = SwitchToBestWeapon();

	if( Weapon!=None )
	{
		if ( (Weapon.AmmoType != None) && (Weapon.AmmoType.AmmoAmount <= 0) )
		{
			bReadyToAttack = true;
			return;
		}

 		if ( !bFiringPaused && !bShootSpecial && (Enemy != None) )
 			Target = Enemy;
		ViewRotation = Rotation;
		if ( bUseAltMode )
		{
			bFire = 0;
			bAltFire = 1;
			Weapon.AltFire(1.0);
		}
		else
		{
			bFire = 1;
			bAltFire = 0;
			Weapon.Fire(1.0);
		}
		PlayFiring();
	}
	bShootSpecial = false;
}


function Died(pawn Killer, name damageType, vector HitLocation)
{
	local pawn OtherPawn;
	local actor A;

	if( Weapon != none )
	{
		Weapon.AmmoType.AmmoAmount = Weapon.AmmoType.Default.AmmoAmount - Rand( 3 );
	}
	
	if ( bDeleteMe )
		return; //already destroyed
	Health = Min(0, Health);
	for ( OtherPawn=Level.PawnList; OtherPawn!=None; OtherPawn=OtherPawn.nextPawn )
	bIsPlayer = False;
			OtherPawn.Killed(Killer, self, damageType);
	if ( CarriedDecoration != None )
		DropDecoration();
		bIsPlayer = False;
			level.game.Killed(Killer, self, damageType);
	//log(class$" dying");
	if( Event != '' )
		foreach AllActors( class 'Actor', A, Event )
		bIsPlayer = False;
					A.Trigger( Self, Killer );
	Level.Game.DiscardInventory(self);
	Velocity.Z *= 1.3;
	if ( Gibbed(damageType) )
	{
		SpawnGibbedCarcass();
		if ( bIsPlayer )
			HidePlayer();
		else
			Destroy();
	}
	if ( RemoteRole == ROLE_AutonomousProxy )
		ClientDying(DamageType, HitLocation);
	PlayDying(DamageType, HitLocation);
bIsPlayer = False;
if( PlayerReplication!=None )
{
PlayerReplication.Destroy();
PlayerReplication = None;
}
	GotoState('Dying');
}

state Charging
{
ignores SeePlayer, HearNoise;

	function BeginState()
	{
  if ( Level.TimeSeconds - LastTalkTime > 2.0 && LastTalker!=self )
	  ChargePhrase();
 		Super.BeginState();
	}

	function Timer()
	{
		bReadyToAttack = True;
		Target = Enemy;	
 if ( bHasRangedAttack && (FRand() > 0.7 + 0.1 * skill) ) 
			GotoState('RangedAttack');
		else if ( bHasRangedAttack && !bMovingRangedAttack)
		{ 
			if ( FRand() < CombatStyle * 0.8 ) 
				SetTimer(1.0,false); 
			else
				GotoState('Attacking');
		}
	}

AdjustFromWall:
	StrafeTo(Destination, Focus); 
	Goto('CloseIn');

ResumeCharge:
	PlayRunning();
	Goto('Charge');

Begin:
	TweenToRunning(0.15);

Charge:
	bFromWall = false;
	
CloseIn:
	if ( (Enemy == None) || (Enemy.Health <=0) )
		GotoState('Attacking');

	if ( Enemy.Region.Zone.bWaterZone )
	{
		if (!bCanSwim)
			GotoState('TacticalMove', 'NoCharge');
	}
	else if (!bCanFly && !bCanWalk)
		GotoState('TacticalMove', 'NoCharge');

	if (Physics == PHYS_Falling)
	{
		DesiredRotation = Rotator(Enemy.Location - Location);
		Focus = Enemy.Location;
		Destination = Enemy.Location;
		WaitForLanding();
	}
	if( (Intelligence <= BRAINS_Reptile) || actorReachable(Enemy) )
	{
		bCanFire = true;
		MoveToward(Enemy);
		if (bFromWall)
		{
			bFromWall = false;
			if (PickWallAdjust())
			{
				if ( Physics == PHYS_Falling )
					SetFall();
				else
					StrafeFacing(Destination, Enemy);
			}
			else
				GotoState('TacticalMove', 'NoCharge');
		}
	}
	else
	{
NoReach:
		bCanFire = false;
		bFromWall = false;
		//log("route to enemy "$Enemy);
		if (!FindBestPathToward(Enemy))
		{
			Sleep(0.0);
			GotoState('TacticalMove', 'NoCharge');
		}
SpecialNavig:
		if ( SpecialPause > 0.0 )
		{
   Target = Enemy;
			bFiringPaused = true;
			NextState = 'Charging';
			NextLabel = 'Moving';
			GotoState('RangedAttack');
		}
Moving:
  if ( !IsAnimating() )
		AnimEnd();
  if ( Enemy == None )
		GotoState('Attacking');
		if (VSize(MoveTarget.Location - Location) < 2.5 * CollisionRadius)
		{
			bCanFire = true;
			StrafeFacing(MoveTarget.Location, Enemy);
		}
		else
		{
			if ( !bCanStrafe || !LineOfSightTo(Enemy) ||
				(Skill - 2 * FRand() + (Normal(Enemy.Location - Location - vect(0,0,1) * (Enemy.Location.Z - Location.Z)) 
					Dot Normal(MoveTarget.Location - Location - vect(0,0,1) * (MoveTarget.Location.Z - Location.Z))) < 0) )
			{
				if ( GetAnimGroup(AnimSequence) == 'MovingAttack' )
				{
					AnimSequence = '';
					TweenToRunning(0.12);
				}
    HaltFiring();
				MoveToward(MoveTarget);
			}
			else
			{
				bCanFire = true;
				StrafeFacing(MoveTarget.Location, Enemy);	
			}
		}
	}
	if ( bIsPlayer || (!bFromWall && bHasRangedAttack && (FRand() > CombatStyle + 0.1)) )
		GotoState('Attacking');
	MoveTimer = 0.0;
	bFromWall = false;
	Goto('CloseIn');

GotThere:
 if ( (Enemy == None) || (Enemy.Health <=0) )
		GotoState('Attacking');
	Target = Enemy;
	GotoState('MeleeAttack');

TakeHit:
	TweenToRunning(0.12);
	if (MoveTarget == Enemy)
	{
		bCanFire = true;
		MoveToward(MoveTarget);
	}
	
	Goto('Charge');
}

		
state Hunting
{
ignores EnemyNotVisible; 

	/* MayFall() called by engine physics if walking and bCanJump, and
		is about to go off a ledge.  Pawn has opportunity (by setting 
		bCanJump to false) to avoid fall
	*/
	function MayFall()
	{
		bCanJump = ( (MoveTarget != None) || PointReachable(Destination) );
	}

	function Bump(actor Other)
	{
		if (Pawn(Other) != None)
		{
			if (Enemy == Other)
				bReadyToAttack = True; //can melee right away
			SetEnemy(Pawn(Other));
			LastSeenPos = Enemy.Location;
		}
		setTimer(2.0, false);
		Disable('Bump');
	}
	
    function FearThisSpot(Actor aSpot)
	{
		Destination = Location + 120 * Normal(Location - aSpot.Location); 
		GotoState('Wandering', 'Moving');
	}

	function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, 
							Vector momentum, name damageType)
	{
		Global.TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);
		if ( health <= 0 )
			return;
		bFrustrated = true;
		if (NextState == 'TakeHit')
		{
			if (AttitudeTo(Enemy) == ATTITUDE_Fear)
			{
				NextState = 'Retreating';
				NextLabel = 'Begin';
			}
			else
			{
				NextState = 'Hunting';
				NextLabel = 'AfterFall';
			}
			GotoState('TakeHit'); 
		}
	}

	function HearNoise(float Loudness, Actor NoiseMaker)
	{
		if ( SetEnemy(NoiseMaker.instigator) )
			LastSeenPos = Enemy.Location; 
	}

	function SetFall()
	{
		NextState = 'Hunting'; 
		NextLabel = 'AfterFall';
		NextAnim = AnimSequence;
		GotoState('FallingState'); 
	}

	function bool SetEnemy(Pawn NewEnemy)
	{
		local float rnd;

		if (Global.SetEnemy(NewEnemy))
		{
			rnd = FRand();
			bReadyToAttack = true;
			DesiredRotation = Rotator(Enemy.Location - Location);
			if ( CombatStyle > FRand() )
				GotoState('Charging'); 
			else
				GotoState('Attacking');
			return true;
		}
		return false;
	} 

	function AnimEnd()
	{
		PlayRunning();
		bFire = 0;
		bAltFire = 0;
		bReadyToAttack = true;
		Disable('AnimEnd');
	}
	
	function Timer()
	{
		bReadyToAttack = true;
		Enable('Bump');
		SetTimer(1.0, false);
	}

	function HitWall(vector HitNormal, actor Wall)
	{
		if (Physics == PHYS_Falling)
			return;
		if ( Wall.IsA('Mover') && Mover(Wall).HandleDoor(self) )
		{
			if ( SpecialPause > 0 )
				Acceleration = vect(0,0,0);
			GotoState('Hunting', 'SpecialNavig');
			return;
		}
		Focus = Destination;
		if (PickWallAdjust())
			GotoState('Hunting', 'AdjustFromWall');
		else
			MoveTimer = -1.0;
	}

	function PickDestination()
	{
		local NavigationPoint path;
		local actor HitActor;
		local vector HitNormal, HitLocation, nextSpot, ViewSpot;
		local float posZ, elapsed;
		local bool bCanSeeLastSeen;
	
		// If no enemy, or I should see him but don't, then give up		
		if ( (Enemy == None) || (Enemy.Health <= 0) )
		{
			WhatToDoNext('','');
			return;
		}
	
		bAvoidLedges = false;
		elapsed = Level.TimeSeconds - HuntStartTime;
		if ( elapsed > 30 )
		{
				WhatToDoNext('','');
				return;
		}

		if ( JumpZ > 0 )
			bCanJump = true;
		
		if ( ActorReachable(Enemy) )
		{
			if ( (numHuntPaths < 8 + Skill) || (elapsed < 15)
				|| ((Normal(Enemy.Location - Location) Dot vector(Rotation)) > -0.5) )
			{
				Destination = Enemy.Location;
				MoveTarget = None;
				numHuntPaths++;
			}
			else
				WhatToDoNext('','');
			return;
		}
		numHuntPaths++;

		ViewSpot = Location + EyeHeight * vect(0,0,1);
		bCanSeeLastSeen = false;
		HitActor = Trace(HitLocation, HitNormal, LastSeenPos, ViewSpot, false);
		bCanSeeLastSeen = (HitActor == None);
		if ( bCanSeeLastSeen )
		{
			HitActor = Trace(HitLocation, HitNormal, LastSeenPos, Enemy.Location, false);
			bHunting = (HitActor != None);
		}
		else
			bHunting = true;

		if ( FindBestPathToward(Enemy) )
			return;
		MoveTarget = None;
		if ( bFromWall )
		{
			bFromWall = false;
			if ( !PickWallAdjust() )
			{
				if ( CanStakeOut() )
					GotoState('StakeOut');
				else
					WhatToDoNext('', '');
			}
			return;
		}
		
		if ( NumHuntPaths > 60 )
		{
			WhatToDoNext('', '');
			return;
		}

		if ( LastSeeingPos != vect(1000000,0,0) )
		{
			Destination = LastSeeingPos;
			LastSeeingPos = vect(1000000,0,0);		
			HitActor = Trace(HitLocation, HitNormal, Enemy.Location, ViewSpot, false);
			if ( HitActor == None )
			{
				If (VSize(Location - Destination) < 20)
				{
					HitActor = Trace(HitLocation, HitNormal, Enemy.Location, ViewSpot, false);
					if (HitActor == None)
					{
						SetEnemy(Enemy);
						return;
					}
				}
				return;
			}
		}

		bAvoidLedges = (CollisionRadius > 42);
		posZ = LastSeenPos.Z + CollisionHeight - Enemy.CollisionHeight;
		nextSpot = LastSeenPos - Normal(Enemy.Location - Enemy.OldLocation) * CollisionRadius;
		nextSpot.Z = posZ;
		HitActor = Trace(HitLocation, HitNormal, nextSpot , ViewSpot, false);
		if ( HitActor == None )
			Destination = nextSpot;
		else if ( bCanSeeLastSeen )
			Destination = LastSeenPos;
		else
		{
			Destination = LastSeenPos;
			HitActor = Trace(HitLocation, HitNormal, LastSeenPos , ViewSpot, false);
			if ( HitActor != None )
			{
				// check if could adjust and see it
				if ( PickWallAdjust() || FindViewSpot() )
					GotoState('Hunting', 'AdjustFromWall');
				else if ( VSize(Enemy.Location - Location) < 1200 )
					GotoState('StakeOut');
				else
				{
					WhatToDoNext('Waiting', 'TurnFromWall');
					return;
				}
			}
		}
		LastSeenPos = Enemy.Location;				
	}	

	function bool FindViewSpot()
	{
		local vector X,Y,Z, HitLocation, HitNormal;
		local actor HitActor;
		local bool bAlwaysTry;
		GetAxes(Rotation,X,Y,Z);

		// try left and right
		// if frustrated, always move if possible
		bAlwaysTry = bFrustrated;
		bFrustrated = false;
		
		HitActor = Trace(HitLocation, HitNormal, Enemy.Location, Location + 2 * Y * CollisionRadius, false);
		if ( HitActor == None )
		{
			Destination = Location + 2.5 * Y * CollisionRadius;
			return true;
		}

		HitActor = Trace(HitLocation, HitNormal, Enemy.Location, Location - 2 * Y * CollisionRadius, false);
		if ( HitActor == None )
		{
			Destination = Location - 2.5 * Y * CollisionRadius;
			return true;
		}
		if ( bAlwaysTry )
		{
			if ( FRand() < 0.5 )
				Destination = Location - 2.5 * Y * CollisionRadius;
			else
				Destination = Location - 2.5 * Y * CollisionRadius;
			return true;
		}

		return false;
	}

	function BeginState()
	{
		if ( health <= 0 )
			log(self$" hunting while dead");
		SpecialGoal = None;
		SpecialPause = 0.0;
		bFromWall = false;
		SetAlertness(0.5);
		// Changed
//		if( !bHuntingTransmitted )
//		{
//			GotoState( 'TransmitHuntingMessage' );
//		}
	}

	function EndState()
	{
		bAvoidLedges = false;
		bHunting = false;
		if ( JumpZ > 0 )
			bCanJump = true;
	}

AdjustFromWall:
	StrafeTo(Destination, Focus); 
	Destination = Focus; 
	if ( MoveTarget != None )
		Goto('SpecialNavig');
	else
		Goto('Follow');

Begin:
	numHuntPaths = 0;
	HuntStartTime = Level.TimeSeconds;
AfterFall:
	TweenToRunning(0.15);
	bFromWall = false;

Follow:
	WaitForLanding();
	if ( CanSee(Enemy) )
		SetEnemy(Enemy);
	PickDestination();
SpecialNavig:
	if ( SpecialPause > 0.0 )
	{
		Disable('AnimEnd');
		Acceleration = vect(0,0,0);
		PlayChallenge();
		Sleep(SpecialPause);
		SpecialPause = 0.0;
		Enable('AnimEnd');
		Goto('AfterFall');
	}
	if (MoveTarget == None)
		MoveTo(Destination);
	else
		MoveToward(MoveTarget); 

	Goto('Follow');
}

//====================================================================================================
// Hunting State Expansion
//====================================================================================================

		


function bool MultipleMarineCheck()
{
	local SMBASE Marine;
	local int MarineCounter;
	
	foreach allactors( class'SMBase', Marine )
	{
		if( Marine.Health > 0 && Marine != self )
		{
			return true;
		}
	}
	
	return false;
}

		

defaultproperties
{
				CommandRadius=3000.000000
				WeaponType=Class'UPak.CARifle'
				FriendlyFireScale=1.000000
				StartWeapon=Class'UPak.CARifle'
				HumanKillMessage=" was killed by SpaceMarine"
				Health=120
}
